c$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$
c  Convol.x par=[  ]   >out.H
c
c  Author: Mihai     AUG 90
c  Functions: Convolve input data with wavelet
c
c       from history:  integer n1, n2, n3
c	from par: integer nsampl=1
c
c       ntp=n1+125-1
c
c
c
c
c source in /sep/mihai/dev/Vel/Convol.fs
c$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$
c%
        integer n1,n2,n3,ntp

        from history:  integer n1, n2, n3

        ntp=n1+125-1
	allocate:   real data1(n1,n2,n3), data2(ntp)
	
	subroutine convolve(n1,n2,n3,ntp,data1,data2)
        integer  n1,n2,n3,ntp
        integer  esize,nsampl
        integer  it,iw,ix,iz,np,ip

        REAL     DATA1(n1,n2,n3),data2(ntp)
        real     halfw(63),wavelet(125)

        data halfw  /
     &	1.764345E-03,2.576722E-03,3.047558E-03,3.016921E-03,
     &	2.605916E-03,2.196657E-03,2.242794E-03,2.998808E-03,
     &  4.323286E-03,5.692076E-03,6.44902E-03,6.179813E-03,
     &	5.000003E-03,3.568002E-03,2.772822E-03,3.235586E-03,
     &   4.89769E-03,6.954442E-03,8.223221E-03,7.787722E-03,
     &	5.573235E-03,2.503356E-03,9.012813E-05,-3.753605E-04,
     &	1.392875E-03,4.379421E-03,6.694086E-03,6.562323E-03,
     &	3.371305E-03,-1.829862E-03,-6.732948E-03,-8.951747E-03,
     &	-7.391328E-03,-3.036263E-03,1.365858E-03,2.676171E-03,
     &	-8.730142E-04,-8.488163E-03,-1.695114E-02,-2.216093E-02,
     &	-2.137438E-02,-1.495089E-02,-6.548199E-03,-1.462817E-03,
     &   -3.818497E-03,-1.404144E-02,-2.808234E-02,-3.905739E-02,
     &	-4.072597E-02,-3.113304E-02,-1.443052E-02,3.910369E-04,
     &   3.644562E-03,-9.801234E-03,-3.673495E-02,-6.543839E-02,
     &	-7.974487E-02,-6.590544E-02,-1.933651E-02,5.190222E-02,
     &	.1287919,.1878639,.21 /

        esize=4
        np=125
	
	from par: integer nsampl=1

        call putch('n1','i',n1)
        call putch('n2','i',n2)
        call putch('n3','i',n3)
        call hclose()

	call sreed('in',data1,n1*n2*n3*esize)

	ip=0
        if(nsampl.lt.1) nsampl=1
	do iw=63-nsampl+1,63
          ip=ip+1
	  wavelet(ip)=halfw(iw)
	enddo
        do iw=1,nsampl-1
	  ip=ip+1
          wavelet(ip)=halfw(63-iw)
        enddo
        np=ip

C Convolve the data with the wavelet
        do iz=1,n3
          do ix=1,n2
            do it=1,ntp
              data2(it)=0.
            enddo
            do it=1,n1
              do iw=1,np
                data2(it+iw-1)=data2(it+iw-1)+data1(it,ix,iz)*
     &          wavelet(iw)
              enddo
            enddo
            do it=1,n1
              data1(it,ix,iz)=data2(it+nsampl-1)
            enddo
          enddo
        enddo
C
C     WRITE THE FINAL ANSWER TO DISC
C
C
        call srite('out',data1,n1*n2*n3*esize)
        RETURN
        END






