C######## ######### ######### ######### ######### ######### ######### ##
C  <COdata(nt,ny) Gaz2Dprecm  v= >ZOdata.H
C
C  File:DSRfftdrv.fs
C  Author: Mihai Popovici Aug 93
C
C        from history: integer n1:nt,n2:ny,n3:nh
C        from history: real d1:dt,d2:dy,d3:dh
C	 from par:     integer nz=64
C        from par:     real dz=10
C	
C
C  Input   Constant-Offset data (single offset)
C  Output  Zero-Offset data
C 
C source=/homes/sep/mihai/dev/DSR/DSRfftdrv.fs
C
C######## ######### ######### ######### ######### ######### ######### ##
c%
        integer adj,nt,nh,ny,nz
	real    dt,dy,dh,dz

	from par:     integer adj=1
	if(adj.eq.0) then
          from history: integer n1:nz,n2:ny
          from history: real    d1:dz,d2:dy
	  from par:     integer nt=64,nh=16
	  from par:     real    dt=10,dh=10
	else
          from history: integer n1:nt,n2:ny,n3:nh
          from history: real    d1:dt,d2:dy,d3:dh
	  from par:     integer nz=64
	  from par:     real    dz=10 
	endif

	allocate: real    v(nz)

        subroutine Gpre(adj,dt,nt,dh,nh,dy,ny,dz,nz,v)
        integer adj,nt,ny,nh,nz
        real    dt,dy,dh,dz
	real    v(nz)

	integer esize
	call cmf_init()
	esize=4
	if(adj.eq.0) then
          call putch('n1','i',nt)
          call putch('n2','i',ny)
          call putch('n3','i',nh)
          call putch('d1','f',dt)
          call putch('d2','f',dy)
          call putch('d3','f',dh)
	else
          call putch('n1','i',nz)
          call putch('n2','i',ny)
          call putch('n3','i',1)
          call putch('d1','f',dz)
          call putch('d2','f',dy)
          call putch('d3','f',1)
	endif
	call putch('esize','i',esize)
        call hclose()

	call sreed('vel',v,nz*esize)

        call Gprecm(adj,dt,nt,dh,nh,dy,ny,dz,nz,v)

	return
	end







