c$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$
c  Vel2D.x par=[  ]   >out.H
c
c  VEL_MODEL.FS Module for
c  Author: Mihai     MAY/90
c  Functions: 
c
c  If VelType=0 output velocity
c  Else         output slowness
c
c source in /homes/mihai/dev/Vel/Vel2D.fs
c$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$
c%
	integer nx,nz,nz0,nz1,nz2,nz3,nz4,nz5,VelType,smooth
	real    dx,dz,a0,a1,a2,a3,a4,a5

	from par:   integer nx=1,nz=64
	from par:   integer VelType=0
        from par:   integer nz0=0,nz1=1,nz2=2,nz3=3,nz4=4,nz5=5
	from par:   real dx=10,dz=10
	from par:   real a0=1000,a1=1000,a2=1000
	from par:   real a3=1000,a4=1000,a5=1000
	from par:   integer smooth=0

	allocate:	real velocity(nz,nx)
	allocate:	real tempv(nz)

	subroutine velocity_model(velocity,tempv,nz,nx,nz0,nz1,nz2,
nz3,nz4,nz5,a0,a1,a2,a3,a4,a5,dx,dz,VelType,smooth)
	integer nx,nz,nz0,nz1,nz2,nz3,nz4,nz5,VelType,smooth
	real    velocity(nz,nx),tempv(nz)
	real    dz,dx,a0,a1,a2,a3,a4,a5

	integer iz,ix,is,i
	integer esize
	real da1,da2,da3,da4,da5,v

	esize=4

	call putch('n1','i',nz)
	call putch('n2','i',nx)
	call putch('n3','i',1)
	call putch('o1','i',0)
	call putch('o2','i',0)
	call putch('o3','i',0)
	call putch('d1','f',dz)
	call putch('d2','f',dx)
        call hclose()

        if(nz0.ge.nz1.or.nz1.ge.nz2.or.nz2.ge.nz3.or.nz3.ge.nz4.or.
     &    nz4.ge.nz5.or.nz5.ge.nz) then
          write(0,*) 'Wrong sequence n0...nz5'
          return
        endif
        
	da1=(a1-a0)/(nz1-nz0)
        da2=(a2-a1)/(nz2-nz1)
        da3=(a3-a2)/(nz3-nz2)
        da4=(a4-a3)/(nz4-nz3)
        da5=(a5-a4)/(nz5-nz4)


	do iz=1,nz0
	  tempv(iz)=a0
        enddo
	do iz=nz0+1,nz1
	  tempv(iz)=a0+da1*(iz-nz0)
        enddo
	do iz=nz1+1,nz2
	  tempv(iz)=a1+da2*(iz-nz1)
	enddo
	do iz=nz2+1,nz3
	  tempv(iz)=a2+da3*(iz-nz2)
	enddo
	do iz=nz3+1,nz4
	  tempv(iz)=a3+da4*(iz-nz3)
	enddo
	do iz=nz4+1,nz5
	  tempv(iz)=a4+da5*(iz-nz4)
	enddo
	do iz=nz5+1,nz
	  tempv(iz)=a5
	enddo
	if(smooth.ne.0) then
	  do iz=1,smooth
            v=0.
	    do i=1,iz
              v=v+tempv(i)
	    enddo
	    velocity(iz,1)=v/iz
	  enddo
	  do iz=smooth+1,nz-smooth
            v=0.
	    do is=1,smooth
	      v=v+tempv(iz-is)+tempv(iz+is)
	    enddo
	    v=v+tempv(iz)
	    v=v/(2*smooth+1)
	    velocity(iz,1)=v
	  enddo
	  do iz=nz-smooth+1,nz
            v=0.
	    do i=nz-smooth+1,iz
              v=v+tempv(i)
	    enddo
	    velocity(iz,1)=v/(iz-nz+smooth)
	  enddo
	  do ix=2,nx
	    do iz=1,nz
              velocity(iz,ix)=velocity(iz,1)
	    enddo
	  enddo
	else
	  do ix=1,nx
	    do iz=1,nz
              velocity(iz,ix)=tempv(iz)
	    enddo
	  enddo
	endif
	if(VelType.ne.0) then
	  do ix=1,nx
	    do i=1,nz
	     velocity(i,ix)=1./velocity(i,ix)
	    enddo
	  enddo
	endif
	call srite('out',velocity,nz*nx*esize)
	stop
	end

